# utils

## functions

### utils.emptify

Removes all logically empty keys/values from input, and renders result as JSON.

Used to determine if the input is logically empty for purposes of conditional rendering.

Typically used like this:

```yaml
{{- if .Values.foo | include "utils.emptify" | fromJson }}
...
{{- end }}
```

or, in some cases

```yaml
{{- with .Values.foo | include "utils.emptify" | fromJson }}
...
{{- end }}
```

Be aware that in this scenario, you're working with trimmed, "emptified" structure, which will be lacking some of the
dropped maps/lists.
While this may be good enough for simple structures, in more complex scenarios you may want to do this:

```yaml
{{- if .Values.foo | include "utils.emptify" | fromJson }}
{{- with .Values.foo }}
...
{{- end }}
{{- end }}
```

**Rationale** behind this is as follows:

Complex structures may be defined in values that are lacking actual content, and serve merely as structure definition.
Consider:

```yaml
image:
  registry: ~
  name: ~
  tag: ~
```

For all practical purposes, this is empty/dummy structure, and you might want to do following in your template:

```yaml
{{- with .Values.image }}
image: {{ printf "%s/%s:%s" .registry .name .tag}}
{{- end}}
```

Intention here is to render the `image` key and its value only when the actual data is specified.

However, Helm template treats empty/undefined `.image.*` subkeys as data, and both `{{ if }}` and `{{ with }}` evaluate
to `truthy` instead of expected `falsey`.

User is forced to check multiple scalars:

```yaml
{{- with .Values.image}}
{{- if and .registry .name .tag}}
image: {{ printf "%s/%s:%s" .registry .name .tag}}
{{- end}}
{{- end}}
```

While this may be the most reasonable approach in many cases, there are complex scenarios where user would benefit from
having a more powerful tool at their disposal, and `utils.emptify` tries to be just that.

---

## Values

| Key | Type | Default | Description |
|-----|------|---------|-------------|
| fullnameOverride | string | `nil` |  |
| global.chart | object | `{"appVersion":null,"name":null,"version":null}` | top level chart |
| global.chart.name | string | {...} | chart name |
| global.labels.common."app.kubernetes.io/component" | string | `"{{.Chart.Name}}"` |  |
| global.labels.common."app.kubernetes.io/instance" | string | `"{{.Release.Name}}"` |  |
| global.labels.common."app.kubernetes.io/managed-by" | string | `"{{.Release.Service}}"` |  |
| global.labels.common."app.kubernetes.io/name" | string | `"{{.Release.Name}}"` |  |
| global.labels.common."app.kubernetes.io/part-of" | string | `"{{.Release.Namespace}}"` |  |
| global.labels.common."app.kubernetes.io/version" | string | `"{{.Chart.AppVersion | default \"undefined\" | replace \".\" \"-\" | replace \"+\" \"-\" }}"` |  |
| global.labels.selector.app | string | `"{{.Release.Name}}"` |  |
| global.release.name | string | `nil` |  |
| nameOverride | string | `nil` |  |
| useChartPrefix | string | `nil` |  |
| useReleasePrefix | string | `nil` |  |

----------------------------------------------
Autogenerated from chart metadata using [helm-docs v1.12.0](https://github.com/norwoodj/helm-docs/releases/v1.12.0)